package com.njyunzhi.nanyang.common;

import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.njyunzhi.nanyang.common.gps.Gps;
import com.njyunzhi.nanyang.common.gps.GpsUtil;
import com.njyunzhi.nanyang.config.AmapConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class AmapUtil {

    @Autowired
    AmapConfig config;

    public JSONObject regeo(String location) {
        if (null == location || "".equals(location.trim()) || location.length() < 5) {
            return null;
        }

        String[] parts = location.split(",");
        double lng = Double.parseDouble(parts[0]);
        double lat = Double.parseDouble(parts[1]);

//        Gps gps = GpsUtil.gps84_To_Gcj02(lat, lng);
//        String loc = String.format("%f,%f", gps.getWgLon(), gps.getWgLon());
        String loc = location;

        for(String key : config.getKeys()) {
            try {
                JSONObject res = getRego1(key, loc);
                return res;
            } catch (Exception e) {
                //
            }
        }

        return null;
    }

    public JSONObject getRego1(String key, String loc) throws Exception {
        String url = String.format("http://restapi.amap.com/v3/geocode/regeo?key=%s&location=%s&radius=1000&extensions=base&batch=false&roadlevel=0", key, loc);
        String resp = HttpUtil.get(url);
        log.info("接口【{}】 返回【{}】", url, resp);

        JSONObject result = JSON.parseObject(resp);

        if (!"1".equals(result.getString("status"))) {
            throw new Exception(result.getString("info"));
        }

        JSONObject regeocode = result.getJSONObject("regeocode");
        return regeocode;
    }
}
