package com.njyunzhi.nanyang.task;

import com.njyunzhi.nanyang.service.TaLocationService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

@Slf4j
@Component
public class SyncLocation {

    @Autowired
    TaLocationService taLocationService;

    /**
     * 每 5 分钟 同步一次定位信息
     */
    @Scheduled(cron = "0 */5 * * * ?")
    public void run() {
        try {
            log.info("=================开始同步位置信息==");
            taLocationService.syncLocation();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @PostConstruct
    public void start() {
        // 系统启动立即执行一次
        run();
    }
}
